"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.didTxSucceed = exports.isErrorStatus = void 0;
function isErrorStatus(s) {
    if (typeof s === 'string') {
        return s === 'Failure';
    }
    return 'Failure' in s;
}
exports.isErrorStatus = isErrorStatus;
/**
 *
 * @param txId
 * @returns true if success, false otherwise
 */
function didTxSucceed(near, accountId, txId) {
    return __awaiter(this, void 0, void 0, function* () {
        // It's not exactly this. Actual rpc response has more fields, but we only
        // need these fields for what we're doing. RPC will throw its own errors,
        // so it's fine to use the type as is.
        const ret = yield near.connection.provider.sendJsonRpc('EXPERIMENTAL_tx_status', [txId, accountId]);
        const hasError = ret.receipts_outcome.some((o) => {
            return isErrorStatus(o.outcome.status);
        });
        return !isErrorStatus(ret.status) && !hasError;
    });
}
exports.didTxSucceed = didTxSucceed;
